'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _States = require('./States');

var STATE = _interopRequireWildcard(_States);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _ref = [ArrayBuffer || Object, ArrayBufferView || Object, URLSearchParams || Object],
    ArrayBuffer = _ref[0],
    ArrayBufferView = _ref[1],
    URLSearchParams = _ref[2];


var getConfig = function getConfig(props) {
    var url = props.url,
        method = props.method,
        headers = props.headers,
        params = props.params,
        data = props.data,
        timeout = props.timeout,
        auth = props.auth,
        responseType = props.responseType,
        xsrfCookieName = props.xsrfCookieName,
        xsrfHeaderName = props.xsrfHeaderName;


    return {
        url: url, method: method, headers: headers, params: params,
        data: data, timeout: timeout, auth: auth, responseType: responseType,
        xsrfCookieName: xsrfCookieName, xsrfHeaderName: xsrfHeaderName
    };
};

var Request = function (_React$Component) {
    (0, _inherits3.default)(Request, _React$Component);

    function Request(props) {
        (0, _classCallCheck3.default)(this, Request);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Request.__proto__ || (0, _getPrototypeOf2.default)(Request)).call(this, props));

        _this.onSuccess = function () {
            _this.props.onSuccess(_this.state.response);
        };

        _this.onFailure = function () {
            _this.props.onFailure(_this.state.response);
        };

        _this.onError = function () {
            _this.props.onError(_this.state.error);
        };

        _this.fire = function () {
            var config = getConfig(_this.props);

            // remove the undefined keys
            (0, _keys2.default)(config).map(function (k) {
                return config[k] === undefined ? delete config[k] : false;
            });

            _this.setState({ status: STATE.START }, _this.props.onStart);
            _axios2.default.request(config).then(function (response) {
                var code = Math.round(response.status / 100);
                switch (code) {
                    case 2:
                        _this.setState({ status: STATE.SUCCESS, response: response }, _this.props.onSuccess ? _this.onSuccess : undefined);
                        break;
                    default:
                        _this.setState({ status: STATE.FAILURE, response: response }, _this.props.onFailure ? _this.onFailure : undefined);
                }
            }).catch(function (err) {
                _this.setState({ status: STATE.ERROR, error: err }, _this.props.onError ? _this.onError : undefined);

                // throwing the error prior to setting state,
                // prevents error block from getting displayed
                // also, always false, we want to propagate the root causes
                (0, _invariant2.default)(false, err.stack);
            });
        };

        _this.state = {
            status: STATE.INIT,
            response: null,
            error: null,
            tag: props.tag
        };
        return _this;
    }

    // noinspection JSUnusedGlobalSymbols


    (0, _createClass3.default)(Request, [{
        key: 'getChildContext',
        value: function getChildContext() {
            return (0, _extends3.default)({}, this.state);
        }
    }, {
        key: 'render',
        value: function render() {
            var children = this.props.children;


            (0, _invariant2.default)(children || _react2.default.Children.count(children) === 1, 'A <Request> may have only one child element');

            return children ? _react2.default.Children.only(children) : null;
        }

        /**
         * componentDidMount() is invoked immediately after a component is mounted.
         * Initialization that requires DOM nodes should go here.
         * If you need to load data from a remote endpoint,
         * this is a good place to instantiate the network request.
         * Setting state in this method will trigger a re-rendering.
         */

    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (!this.props.defer) {
                this.fire();
            }
        }

        /**
         * componentDidUpdate() is invoked immediately after updating occurs.
         * This method is not called for the initial render.
         * Use this as an opportunity to operate on the DOM when the component has been updated.
         * This is also a good place to do network requests as long as you compare
         * the current props to previous props
         * (e.g. a network request may not be necessary if the props have not changed).
         */

    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            // we don't need to consider the state change to determine
            // whether the component should be updated
            // since the state change is actually not reflected
            // we wanted to do all this in `shouldComponentUpdate`,
            // but we do want to update the children when state changes
            // we'll be checking if any of the props has changed the config for the axios
            // if the config has been changed only then the request should be fired

            // this should be slow as heck,
            // will change the implementation asap
            if ((0, _stringify2.default)(getConfig(this.props)) === (0, _stringify2.default)(getConfig(prevProps))) {
                return;
            }

            if (!this.props.defer) {
                this.fire();
            }
        }
    }]);
    return Request;
}(_react2.default.Component);

/*
 * See: https://github.com/mzabriskie/axios#request-config
 * More PropTypes will be added as & when required.
 */


Request.propTypes = {
    // `url` is the server URL that will be used for the request
    url: _propTypes2.default.string.isRequired,

    // the http method is not required by axios &
    // defaults to 'get' if not provided
    method: _propTypes2.default.oneOf(['get', 'post', 'put', 'patch', 'delete', 'head']),

    // `headers` are custom headers to be sent
    headers: _propTypes2.default.object,

    // `params` are the URL parameters to be sent with the request
    // Must be a plain object or a URLSearchParams object
    params: _propTypes2.default.object,

    // `data` is the data to be sent as the request body
    // Only applicable for request methods 'PUT', 'POST', and 'PATCH'
    // When no `transformRequest` is set, must be of one of the following types:
    // - string, plain object, ArrayBuffer, ArrayBufferView, URLSearchParams
    // - Browser only: FormData, File, Blob
    // - Node only: Stream
    data: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.instanceOf(ArrayBuffer), _propTypes2.default.instanceOf(ArrayBufferView), _propTypes2.default.instanceOf(URLSearchParams)]),

    // `paramsSerializer` is an optional function in charge of serializing `params`
    // (e.g. https://www.npmjs.com/package/qs, http://api.jquery.com/jquery.param/)
    // default: function(params) { return Qs.stringify(params, {arrayFormat: 'brackets'}) }
    paramsSerializer: _propTypes2.default.func,

    // `transformRequest` allows changes to the request data before it is sent to the server
    // This is only applicable for request methods 'PUT', 'POST', and 'PATCH'
    // The last function in the array must return a string, an ArrayBuffer, FormData, or a Stream
    transformRequest: _propTypes2.default.arrayOf(_propTypes2.default.func),

    // `transformResponse` allows changes to the response data to be made before
    // it is passed to then/catch
    transformResponse: _propTypes2.default.arrayOf(_propTypes2.default.func),

    // `validateStatus` defines whether to resolve or reject the promise for a given
    // HTTP response status code. If `validateStatus` returns `true` (or is set to `null`
    // or `undefined`), the promise will be resolved; otherwise, the promise will be
    // rejected.
    // default: function (status) { return status >= 200 && status < 300; }
    validateStatus: _propTypes2.default.func,

    // `maxRedirects` defines the maximum number of redirects to follow in node.js.
    // If set to 0, no redirects will be followed.
    // default: 5
    maxRedirects: _propTypes2.default.number,

    // `timeout` specifies the number of milliseconds before the request times out.
    // If the request takes longer than `timeout`, the request will be aborted.
    timeout: _propTypes2.default.number,

    // `auth` indicates that HTTP Basic auth should be used, and supplies credentials.
    // This will set an `Authorization` header, overwriting any existing
    // `Authorization` custom headers you have set using `headers`.
    // { username: 'janedoe', password: 's00pers3cret' }
    auth: _propTypes2.default.shape({
        username: _propTypes2.default.string,
        password: _propTypes2.default.string
    }),

    // `responseType` indicates the type of data that the server will respond with
    // options are 'arraybuffer', 'blob', 'document', 'json', 'text', 'stream'
    // default: json
    responseType: _propTypes2.default.oneOf(['arraybuffer', 'blob', 'document', 'json', 'text', 'stream']),

    // `xsrfCookieName` is the name of the cookie to use as a value for xsrf token
    // default: 'XSRF-TOKEN'
    xsrfCookieName: _propTypes2.default.string,

    // `xsrfHeaderName` is the name of the http header that carries the xsrf token value
    // default: 'X-XSRF-TOKEN'
    xsrfHeaderName: _propTypes2.default.string,

    // callback fired just before the request is fired
    onStart: _propTypes2.default.func,

    // callback fired after the response
    // comes back with status 2XX
    onSuccess: _propTypes2.default.func,

    // callback fired after the response
    // comes back with status other 2XX
    onFailure: _propTypes2.default.func,

    // callback fired when
    // something else goes wrong
    onError: _propTypes2.default.func,

    // defer signals the Request component to not fire the
    // request as soon as ready instead construct the request and
    // wait for the manual trigger
    // useful for cases when either the data is incomplete
    // or we want to wait for a CTA
    defer: _propTypes2.default.bool,

    // request can be tagged for enabling nested scenarios
    // we might want to render a component based on
    // request sent way above the hierarchy of the component
    // super grand parent component :P
    tag: _propTypes2.default.string
};

Request.childContextTypes = {
    status: _propTypes2.default.oneOf(STATE.ALL),
    response: _propTypes2.default.object,
    error: _propTypes2.default.object,
    tag: _propTypes2.default.string
};

exports.default = Request;